/*
 * Copyright (c) 2010-2012 Eike Stepper (Berlin, Germany) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Eike Stepper - initial API and implementation
 */
package org.eclipse.emf.cdo.location;

import org.eclipse.emf.cdo.common.branch.CDOBranchPoint;

/**
 * A CDO server independent representation of a {@link CDOBranchPoint branch point} in a repository.
 * 
 * @author Eike Stepper
 */
public interface ICheckoutSource
{
  public IRepositoryLocation getRepositoryLocation();

  public String getBranchPath();

  public long getTimeStamp();
}
